# Interface Digraph<E,V>

All Superinterfaces:
  `DigraphIteration<E,V>`

All Known Implementing Classes:
  `MapDigraph`

public interface Digraph<E,V> extends DigraphIteration<E,V>

Since:
  3.1

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `addAllVertices(Collection<? extends E> vertices)`
  `boolean`
  `addVertex(E vertex)`
  `boolean`
  `containsAllVertices(Collection<? extends E> vertices)`
  `boolean`
  `containsVertex(E vertex)`
  `V`
  `getArc(E origin, E destination)`
  `boolean`
  `hasArc(E origin, E destination)`
  `int`
  `incomingSize(E vertex)`
  `boolean`
  `isEmpty()`
  `boolean`
  `isIncomingEmpty(E vertex)`
  `boolean`
  `isOutgoingEmpty(E vertex)`
  `int`
  `order()`
  `int`
  `outgoingSize(E vertex)`
  `V`
  `putArc(E origin, E destination, V arc)`
  `boolean`
  `removeAllVertices(Collection<? extends E> vertices)`
  `Object`
  `removeArc(E origin, E destination)`
  `boolean`
  `removeIncoming(E vertex)`
  `boolean`
  `removeOutgoing(E vertex)`
  `boolean`
  `removeVertex(E vertex)`
  `int`
  `size()`

  ### Methods inherited from interface DigraphIteration

  `arcIterator, incomingIterator, outgoingIterator, vertexIterator`

- ## Method Details

  - ### addVertex

    boolean addVertex(E vertex)

  - ### addAllVertices

    boolean addAllVertices(Collection<? extends E> vertices)

  - ### putArc

    V putArc(E origin, E destination, V arc)

  - ### getArc

    V getArc(E origin, E destination)

  - ### removeVertex

    boolean removeVertex(E vertex)

  - ### removeAllVertices

    boolean removeAllVertices(Collection<? extends E> vertices)

  - ### removeArc

    Object removeArc(E origin, E destination)

  - ### removeIncoming

    boolean removeIncoming(E vertex)

  - ### removeOutgoing

    boolean removeOutgoing(E vertex)

  - ### order

    int order()

  - ### size

    int size()

  - ### outgoingSize

    int outgoingSize(E vertex)

  - ### incomingSize

    int incomingSize(E vertex)

  - ### containsVertex

    boolean containsVertex(E vertex)

  - ### containsAllVertices

    boolean containsAllVertices(Collection<? extends E> vertices)

  - ### hasArc

    boolean hasArc(E origin, E destination)

  - ### isEmpty

    boolean isEmpty()

  - ### isOutgoingEmpty

    boolean isOutgoingEmpty(E vertex)

  - ### isIncomingEmpty

    boolean isIncomingEmpty(E vertex)